<html>


<?php

/* catLoan
 * Version 1.0 - 15 Apr 2001
 * Ben Brillat, <brillat-os@mainsheet.org> 
 *
 * A program to keep track of the CD Library
 * Track loans, every 7 days if the CD has not ben
 *   returned send the user an e-mail.
 * Allow users to list their own loans
 * Allow admin users to list all loans
 *                   to create new loans
 *                   to check off returns
 */

//////////////////////
//Configuration
//////////////////////

$datadir = "/home/ben/public_html/files/projects/catLoan/data/";
$dbfile = $datadir . "loandb";
$sysname = "catLoan System v1.0";
$domain = "whatever-your-domain-is.com";
$adminemail = "sysadmin@whatever-your-domain-is.com";
$sysemail = "root@whatever-your-domain-is.com";
$duedays = 7; //only 7 is supported now.
$reminddays = 7; //only 7 is supported now.
$returnto = "78 13th Street (with your name attached)";
$adminusers = array("root", "anyone", "whateveryourusernameis");
$main_url = "https://www.whatever-your-domain-is.com/library-or-something/";
$disable_emails = 1;
$disable_admin = 1;

/////////////////////
//No user-servicable parts after here
/////////////////////

//Load the loan database
function initDB(){

  global $loan, $i;
  global $dbfile;

  if(!file_exists($dbfile)){
    touch($dbfile);
  }
  else{
    $db = fopen($dbfile, "r");
    
    /* read in the data from the db file (up to 1024 chars) */
    for($i = 0; !feof($db); $i++){
      $line = fgets($db, 1024);
      $loan[$i] = split("=", $line);
     }
    fclose($db);
  }
}


//Display the table of loans
function drawTable(){
  
  global $loan, $i;
  global $show_all_loans, $duedays, $PHP_AUTH_USER, $is_admin;
?>
  <center>
  <table border=1><tr>
  <td align=center><h2>ID</h2></td>
  <td align=center><h2>Username</h2></td>
  <td align=center><h2>Loan</h2></td>
  <td align=center><h2>Date</h2></td>
  <td align=center><h2>Returned</h2></td>
  <td align=center><h2>Long-Term</h2></td></tr>

  <form action="index.php" method="post" name="f1">
  <input type=hidden name="doupdate" value="1">

<?php

  for($j = 0; $j < $i; $j++){
    if($loan[$j][0] && ($loan[$j][4] != 1 || $show_all_loans == 1)
       && ($loan[$j][1] == $PHP_AUTH_USER || $is_admin == 1)){
      if($loan[$j][4] == 1){
        print "<tr bgcolor=\"#bbffbb\">\n";
      }
      elseif($loan[$j][5] == 1){
        print "<tr bgcolor=\"#bbbbff\">\n";
      }
      else {
        print "<tr bgcolor=\"#ff9999\">\n";
      }
      print "<td align=center>" . $loan[$j][0] . "</td>\n";
      print "<td align=center>" . $loan[$j][1] . "</td>\n";
      print "<td align=center>" . $loan[$j][2] . "</td>\n";
      print "<td align=center>" . $loan[$j][3] . "</td>\n";
      print "<td align=center><select name=\"returned[" . $loan[$j][0] . "]\">\n";
      if($loan[$j][4] == 1){
	print "<option value=\"Yes\" selected>Yes</option>\n";
	print "<option value=\"No\">No</option>\n";
      }
      else{
	print "<option value=\"Yes\">Yes</option>\n";
	print "<option value=\"No\" selected>No</option>\n";
      }
      print "</select></td>\n";
      print "<td align=center><select name=\"longterm[" . $loan[$j][0] . "]\">\n";
      if($loan[$j][5] == 1){
	print "<option value=\"Yes\" selected>Yes</option>\n";
	print "<option value=\"No\">No</option>\n";
      }
      else{
	print "<option value=\"Yes\">Yes</option>\n";
	print "<option value=\"No\" selected>No</option>\n";
      }
      print "</select></td>\n";
      print "</tr>\n";
    }
  }  
  
  //Adding new entries can only be done by admins
  if($is_admin == 1){
    //srand((double)microtime()*1000000);
    // $new_id = gmdate("Y_m_d-H_i_s-D") . "-" . rand(10,99);
    $new_id = time();
    $new_date = date("d M Y");
    print "<tr><td align=center><input type=hidden name=\"newid\" value=\"" . 
      $new_id . "\">$new_id</td>";
    ?> 
    <td align=center><input type=text name="newuser" size=30></td>
    <td align=center><input type=text name="newloan" size=30></td>
    <td align=center><input type=hidden name="newdate" value=<?php
       print "\"" . $new_date . "\">" . $new_date . "\n";
       ?>
    </td>
        <td align=center><?php
        $duedate = date("d M Y", time() + (86400 * $duedays)); //calculate time from now
        print "Due:<br>" . $duedate . "\n";
   ?></td>
    <td align=center>No</td>
    </tr>
  <?php
  }
  ?>

  </table>

  <?php
   if($is_admin == 1){
     print "<INPUT TYPE=SUBMIT VALUE=\"Update/Insert\">";
   }
  ?>    
 
  </form>

 

  </center>


  <?php

}

function all_or_open(){

  
  global $show_all_loans, $is_admin;

  print "<center><p>\n";

  if($show_all_loans){
    print "<form action=\"index.php\" method=\"post\" name=\"f2\">";
    print "<input type=submit value=\"Show Open Loans\">\n";
  }
  else{
    print "<form action=\"index.php\" method=\"get\" name=\"f2\">";
    print "<input type=hidden name=\"show_all_loans\" value=\"1\">";
    print "<input type=submit value=\"Show All Loans\">\n";
  }

  print "</form><p>\n";


  global $REQUEST_URI;
  print "<a href=\"" . $REQUEST_URI . "\">Refresh Page</a>\n";
  
  if($is_admin == 1){
    print "<p><a href=\"index.php?process_overdue=1\">Process Overdue Loans NOW!</a></center>\n";
  }

}

function add_loan(){
  global $newid, $newuser, $newloan, $newdate;
  global $dbfile, $is_admin;
  

  if($is_admin != 1){
    return;
  }

  //first verify that the user actually exists
  $userhome = "/home/" . $newuser;
  if(!file_exists($userhome)){
    print "<h2>Error!</h2>\n";
    print "The user \"" . $newuser . "\" does not exist on this system.<br>\n";
    print "Please try another username.\n";
    exit -10;
  }

  if(!file_exists($dbfile)){
    touch($dbfile);
  }

  $db = fopen($dbfile, "a");

  //create the new line
  $line = $newid . "=" . $newuser . "=" . $newloan . "=" . $newdate . "=0=0\n";

  //Write out the data to the dbfile - guarantee never longer than 1023.
  fwrite($db, $line, min(strlen($line), 1023));

  fclose($db);
 
  mail_user_newloan($newuser, $newloan);

}

//go through the "returned" array and update the returned bit 
//in the loan db file for returned loans.
function process_returns(){
  global $returned, $longterm, $dbfile;

  if(!file_exists($dbfile)){
    touch($dbfile);
  }
  else{
    $db = fopen($dbfile, "r");
    
    /* read in the data from the db file (up to 1024 chars) */
    for($i = 0; !feof($db); $i++){
      $line = fgets($db, 1024);
      $loan[$i] = split("=", $line);
     }
    fclose($db);
  }
  
  //now write back the file with modified data.
  $db = fopen($dbfile, "w");

  for($j = 0; $j < $i; $j++){
    if($loan[$j][0] != ""){ //make sure this is a real entry.

      $line = $loan[$j][0] . "=" . $loan[$j][1] . "=" . $loan[$j][2] . "=" .
	$loan[$j][3] . "=";
      //if the loan used to be returned, and so long as it isn't marked 
      //as not returned, or if it is now marked returned, set it to be returned.
      if((($loan[$j][4] == 1) && ($returned[$loan[$j][0]] != "No")) ||
	 $returned[$loan[$j][0]] == "Yes"){
	$line .= "1";
      }
      else{
	$line .= "0";
      }
      
      //if the loan used to be long-term, and so long as it isn't marked 
      //as not long-term, or if it is now marked long-term, set it to be long-term.
      if((($loan[$j][5] == 1) && ($longterm[$loan[$j][0]] != "No")) ||
	 $longterm[$loan[$j][0]] == "Yes"){
	$line .= "=1\n";
      }
      else{
	$line .= "=0\n";
      }

      //Write out the data to the dbfile - guarantee never longer than 1023.
      fwrite($db, $line, min(strlen($line), 1023));
    }
  }
  
  fclose($db);
 

 /*
   foreach($returned as $r){
   print $r . ": returned<br>\n";
   }  
 */

}

//send the user an e-mail about the loan and it's due date.
function mail_user_newloan($newuser, $newloan){

  global $disable_emails;

  if($disable_emails){
        return;
  }

  global $sysname, $domain, $adminemail, $sysemail, $duedays, $returnto, $main_url;

  $duedate = date("d M Y", time() + (86400 * $duedays)); //calculate time from now.

  $to = $newuser . "@" . $domain . ", " . $adminemail;
  $subj = "Loan of " . $newloan . " - due back " . $duedate;
  $hdrs = "From: " . $sysemail . "\nReply-To: " . $adminemail . "\nX-Mailer: PHP/" . phpversion();
  $body = "Hello " . $newuser . ",

This is an automated message from the " . $sysname . ".

You have just been loaned \"" . $newloan . "\" from our library.
This material is due back on or before " . $duedate . ".  
Please return it to " . $returnto . " within this time.

You can view the status of this and any other loans that 
you have checked out of the " . $sysname . " by visiting:
" . $main_url . "

If you have any questions, please contact " . $adminemail . "

Thanks!

-". $sysname . "
";
  
  mail($to, $subj, $body, $hdrs);

}

function process_overdue_loans(){
  //go through the database and send e-mails to overdue users as necessary.
  //long term-loans don't get e-mails

  global $loan, $i;
  global $duedays, $reminddays;
  $now = time();
  $today = gmdate("D", $now);

  $i--;

  for($j = 0; $j < $i; $j++){
    if($loan[$j][4] != 1){ //if it's not back yet
      $duestamp = $loan[$j][0] + (86400 * $duedays);
      $calc_due = gmdate("D", $duestamp);
      print "Comparing: " . $loan[$j][0] . $today . $now . $calc_due . $duestamp . "<br>\n";
      
      if(($today == $calc_due) && ($now > $duestamp) && ($loan[$j][5] != 1)){ 
	//if it's an alert day, it's overdue, and it's not long-term, send the overdue e-mail.
	mail_user_overdue($loan[$j][0], $loan[$j][1], $loan[$j][2], $loan[$j][3]);
      }
    }
  }
  
}


//send the user an e-mail about the loan and it's due date.
//(timestamp, username, loaned item, date it was loaned in Human readable format)
function mail_user_overdue($id, $u, $l, $d){

  global $disable_emails;

  if($disable_emails){
        return;
  }

  global $sysname, $domain, $adminemail, $sysemail, $duedays, $returnto, $main_url;

  $duedate = date("d M Y", $id + (86400 * $duedays)); //calculate when originally due.

  $to = $u . "@" . $domain . ", " . $adminemail;
  $subj = "Loan of " . $l . " on " . $d . " - overdue!";
  $hdrs = "From: " . $sysemail . "\nReply-To: " . $adminemail . "\nX-Mailer: PHP/" . phpversion();
  $body = "Hello " . $u . ",

This is an automated message from the " . $sysname . ".

On " . $d . ", you were loaned \"" . $l . "\" from our library.
This material was due back on or before " . $duedate . ", 
and is now overdue.  Please return it to " . $returnto . " as soon as possible.

You can view the status of this and any other loans that 
you have checked out of the " . $sysname . " by visiting:
" . $main_url . "

If you have any questions, please contact " . $adminemail . "

Thanks!

-". $sysname . "
";
  
  mail($to, $subj, $body, $hdrs);

}


//////////////////////////////////////////
//Main program
//////////////////////////////////////////

global $doupdate, $newloan, $process_overdue, $PHP_AUTH_USER;

print "<head><title>" . $sysname . "</title></head>\n";
print "<body bgcolor=\"#ffffff\">\n";

print "<h1 align=center>" . $sysname . "</h1><br>\n";

//Decide if this is an admin user
if(in_array($PHP_AUTH_USER, $adminusers)){
  $is_admin = 1;
}
elseif($disable_admin == 1) {
  $is_admin = 1;
}
else {
  $is_admin = 0;
}

//Now, decide if we're just supposed to process some stuff, or actually
//show a whole web site.
if($process_overdue){
  //visit: http://this.server/path/to/this/script.php?process_overdue=1
  //to run this section.
  initDB();
  process_overdue_loans();
}
else{

  if($doupdate){
    if($newloan != ""){
      add_loan();
    }
    process_returns();
  }
  
  initDB();
  drawTable();
  all_or_open();
  
}

?>

</body>
</html>
